diff --git a/test/unit/daemon/auto_retry/health_test.rb b/test/unit/daemon/auto_retry/health_test.rb
new file mode 100644
index 00000000..e36425b2
--- /dev/null
+++ b/test/unit/daemon/auto_retry/health_test.rb
@@ -0,0 +1,246 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/daemon/auto_retry/health"
+require "hive/daemon/auto_retry/probe_runner"
+require "hive/runtime_identity"
+
+class DaemonAutoRetryHealthTest < Minitest::Test
+  FakeResult = Struct.new(:ok, :exit_status, :timed_out, :signaled, :stdout, :stderr,
+                          :duration_sec, :error, :argv, keyword_init: true) do
+    def healthy?
+      ok == true
+    end
+  end
+
+  class FakeRunner
+    attr_reader :calls
+
+    def initialize(responses)
+      @responses = responses
+      @calls = []
+    end
+
+    def run(argv, timeout_sec:, chdir: nil, stdin_data: nil)
+      @calls << { argv: argv, timeout_sec: timeout_sec, chdir: chdir, stdin_data: stdin_data }
+      key = argv[1..].join(" ")
+      @responses[key] || @responses[argv.join(" ")] || FakeResult.new(ok: false, error: "unexpected",
+                                                                      exit_status: 1, timed_out: false,
+                                                                      signaled: false, stdout: "",
+                                                                      stderr: "", duration_sec: 0.0,
+                                                                      argv: argv)
+    end
+  end
+
+  def with_doctor_green(&block)
+    rows = [ { label: "plan", status: "present" } ]
+    with_doctor_rows(rows, &block)
+  end
+
+  def with_doctor_rows(rows)
+    original = Hive::Commands::Doctor.method(:required_agent_rows)
+    Hive::Commands::Doctor.define_singleton_method(:required_agent_rows) { |**| rows }
+    yield
+  ensure
+    Hive::Commands::Doctor.define_singleton_method(:required_agent_rows, original)
+  end
+
+  def test_codex_login_ok_smoke_fail_is_unhealthy
+    runner = FakeRunner.new(
+      "login status" => FakeResult.new(ok: true, exit_status: 0, timed_out: false, signaled: false,
+                                       stdout: "logged in", stderr: "", duration_sec: 0.1, error: nil, argv: []),
+      "exec --json --skip-git-repo-check -" =>
+        FakeResult.new(ok: false, exit_status: 1, timed_out: false, signaled: false,
+                       stdout: "", stderr: "auth failed", duration_sec: 0.2, error: "nonzero_exit", argv: [])
+    )
+    health = Hive::Daemon::AutoRetry::Health.new(runner: runner)
+    result = with_doctor_green do
+      health.probe_codex({ "execute" => { "agent" => "codex" },
+                           "agents" => { "codex" => { "bin" => "codex" } } })
+    end
+    refute result.healthy
+    assert_equal "codex_smoke_unhealthy", result.rationale
+  end
+
+  def test_codex_healthy_produces_stable_fingerprint
+    runner = FakeRunner.new(
+      "login status" => FakeResult.new(ok: true, exit_status: 0, timed_out: false, signaled: false,
+                                       stdout: "logged in as x", stderr: "", duration_sec: 0.1, error: nil, argv: []),
+      "exec --json --skip-git-repo-check -" =>
+        FakeResult.new(ok: true, exit_status: 0, timed_out: false, signaled: false,
+                       stdout: "{\"type\":\"turn.completed\"}\n", stderr: "", duration_sec: 0.2,
+                       error: nil, argv: [])
+    )
+    health = Hive::Daemon::AutoRetry::Health.new(runner: runner)
+    cfg = { "execute" => { "agent" => "codex" } }
+    a, b = with_doctor_green do
+      first = health.probe_codex(cfg)
+      health.reset_tick_cache!
+      [ first, health.probe_codex(cfg) ]
+    end
+    assert a.healthy
+    assert b.healthy
+    assert_equal a.fingerprint, b.fingerprint
+    refute_includes a.fingerprint, "token"
+    smoke_call = runner.calls.find { |call| call[:argv].include?("--skip-git-repo-check") }
+    assert_equal "Reply with exactly: ok\n", smoke_call[:stdin_data]
+    assert_equal "-", smoke_call[:argv].last
+  end
+
+  def test_codex_zero_exit_without_completion_record_is_unhealthy
+    runner = FakeRunner.new(
+      "login status" => FakeResult.new(ok: true, exit_status: 0, timed_out: false, signaled: false,
+                                       stdout: "logged in", stderr: "", duration_sec: 0.1,
+                                       error: nil, argv: []),
+      "exec --json --skip-git-repo-check -" =>
+        FakeResult.new(ok: true, exit_status: 0, timed_out: false, signaled: false,
+                       stdout: "{\"type\":\"item.completed\"}\n", stderr: "",
+                       duration_sec: 0.2, error: nil, argv: [])
+    )
+
+    result = with_doctor_green do
+      Hive::Daemon::AutoRetry::Health.new(runner: runner).probe_codex(
+        { "execute" => { "agent" => "codex" } }
+      )
+    end
+
+    refute result.healthy
+    assert_equal "codex_smoke_malformed", result.rationale
+  end
+
+  def test_codex_runs_shared_required_doctor_gate_before_cli_probes
+    health = Hive::Daemon::AutoRetry::Health.new(runner: FakeRunner.new({}))
+    rows = [ { label: "plan", status: "missing" } ]
+
+    result = with_doctor_rows(rows) do
+      health.probe_codex({ "execute" => { "agent" => "codex" } })
+    end
+
+    refute result.healthy
+    assert_equal "doctor_unhealthy", result.rationale
+  end
+
+  def test_claude_probes_the_configured_runtime_with_a_bound
+    configured_bin = "/opt/hive-test/claude-custom"
+    runner = FakeRunner.new(
+      "-V" => FakeResult.new(ok: true, exit_status: 0, timed_out: false, signaled: false,
+                              stdout: "tmux 3.4", stderr: "", duration_sec: 0.1,
+                              error: nil, argv: []),
+      "--version" => FakeResult.new(ok: false, exit_status: 1, timed_out: false, signaled: false,
+                                     stdout: "", stderr: "broken install", duration_sec: 0.1,
+                                     error: "nonzero_exit", argv: [])
+    )
+    cfg = {
+      "plan" => { "agent" => "claude" },
+      "agents" => { "claude" => { "bin" => configured_bin } },
+      "claude" => { "mode" => "tmux" }
+    }
+
+    result = with_doctor_green do
+      Hive::Daemon::AutoRetry::Health.new(runner: runner).probe_claude(
+        cfg, stage: "3-plan"
+      )
+    end
+
+    refute result.healthy
+    assert_equal "claude_runtime_unhealthy", result.rationale
+    call = runner.calls.find { |entry| entry[:argv].first == configured_bin }
+    refute_nil call
+    assert_equal Hive::Daemon::AutoRetry::Health::STATUS_TIMEOUT, call[:timeout_sec]
+    readiness = result.probes.find { |entry| entry["name"] == "readiness_detector" }
+    assert_equal true, readiness["ok"]
+  end
+
+  def test_real_probe_runner_drives_fake_codex_with_stdin_json_contract
+    Dir.mktmpdir("hive-fake-codex") do |dir|
+      bin = File.join(dir, "codex")
+      File.write(bin, <<~SH)
+        #!/bin/sh
+        if [ "$1 $2" = "login status" ]; then
+          echo logged-in
+          exit 0
+        fi
+        input=$(cat)
+        [ "$input" = "Reply with exactly: ok" ] || exit 9
+        printf '%s\n' '{"type":"turn.completed","status":"completed"}'
+      SH
+      FileUtils.chmod(0o755, bin)
+      cfg = {
+        "execute" => { "agent" => "codex" },
+        "agents" => { "codex" => { "bin" => bin } },
+        "claude" => { "mode" => "headless" }
+      }
+
+      result = with_doctor_green do
+        Hive::Daemon::AutoRetry::Health.new.probe_codex(cfg)
+      end
+
+      assert result.healthy, result.probes.inspect
+      assert_equal true, result.probes.last["completion_record"]
+    end
+  end
+
+  def test_runtime_identity_snapshot_has_no_secrets
+    snap = Hive::RuntimeIdentity.snapshot
+    assert snap.key?("version")
+    assert snap.key?("code_fingerprint")
+    refute_includes snap.to_s, "SECRET"
+  end
+
+  def test_fresh_cli_identity_requires_complete_matching_json
+    daemon = {
+      "version" => Hive::VERSION,
+      "code_fingerprint" => "code-fingerprint",
+      "binary_path" => "/opt/hive/bin/hive"
+    }
+    matching = FakeResult.new(
+      ok: true, exit_status: 0, timed_out: false, signaled: false,
+      stdout: JSON.generate(daemon), stderr: "", duration_sec: 0.1,
+      error: nil, argv: []
+    )
+    incomplete = FakeResult.new(
+      ok: true, exit_status: 0, timed_out: false, signaled: false,
+      stdout: JSON.generate("version" => Hive::VERSION), stderr: "",
+      duration_sec: 0.1, error: nil, argv: []
+    )
+
+    original_snapshot = Hive::RuntimeIdentity.method(:snapshot)
+    original_binary_path = Hive::RuntimeIdentity.method(:binary_path)
+    Hive::RuntimeIdentity.define_singleton_method(:snapshot) { |**| daemon }
+    Hive::RuntimeIdentity.define_singleton_method(:binary_path) { |**| daemon["binary_path"] }
+
+    good = Hive::Daemon::AutoRetry::Health.new(
+      runner: FakeRunner.new("version --json" => matching)
+    ).send(:identity_matches?)
+    bad = Hive::Daemon::AutoRetry::Health.new(
+      runner: FakeRunner.new("version --json" => incomplete)
+    ).send(:identity_matches?)
+
+    assert_equal({ ok: true, detail: "match" }, good)
+    assert_equal({ ok: false, detail: "cli_identity_incomplete" }, bad)
+  ensure
+    Hive::RuntimeIdentity.define_singleton_method(:snapshot, original_snapshot) if original_snapshot
+    Hive::RuntimeIdentity.define_singleton_method(:binary_path, original_binary_path) if original_binary_path
+  end
+
+  def test_fingerprint_changes_with_config
+    health = Hive::Daemon::AutoRetry::Health.new(runner: FakeRunner.new({}))
+    fp1 = health.fingerprint(recovery_class: :codex_auth_401,
+                             config: { "execute" => { "agent" => "codex" } })
+    fp2 = health.fingerprint(recovery_class: :codex_auth_401,
+                             config: { "execute" => { "agent" => "claude" } })
+    refute_equal fp1, fp2
+  end
+
+  def test_fingerprint_canonicalization_preserves_false
+    health = Hive::Daemon::AutoRetry::Health.new(runner: FakeRunner.new({}))
+    false_fp = health.fingerprint(
+      recovery_class: :codex_auth_401, config: {}, extra: { healthy: false }
+    )
+    nil_fp = health.fingerprint(
+      recovery_class: :codex_auth_401, config: {}, extra: { healthy: nil }
+    )
+
+    refute_equal false_fp, nil_fp
+  end
+end
diff --git a/test/unit/daemon/auto_retry/policy_test.rb b/test/unit/daemon/auto_retry/policy_test.rb
new file mode 100644
index 00000000..77844607
--- /dev/null
+++ b/test/unit/daemon/auto_retry/policy_test.rb
@@ -0,0 +1,64 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/daemon/auto_retry/policy"
+
+class DaemonAutoRetryPolicyTest < Minitest::Test
+  P = Hive::Daemon::AutoRetry::Policy
+  NOW = Time.utc(2026, 6, 1, 12, 0, 0)
+
+  def test_first_retry_immediately_eligible
+    d = P.decide(record: { "attempts_dispatched" => 0 }, healthy_fingerprint: "fp1", now: NOW)
+    assert_equal :retry, d.action
+    assert_equal "first_healthy_signal", d.rationale
+    assert_equal 1, d.attempt_number
+  end
+
+  def test_same_fingerprint_blocks_attempt_two
+    rec = { "attempts_dispatched" => 1, "last_attempted_fingerprint" => "fp1" }
+    d = P.decide(record: rec, healthy_fingerprint: "fp1", now: NOW)
+    assert_equal :refuse, d.action
+    assert_equal "unchanged_fingerprint", d.rationale
+  end
+
+  def test_different_fingerprint_starts_backoff
+    rec = { "attempts_dispatched" => 1, "last_attempted_fingerprint" => "fp1" }
+    d = P.decide(record: rec, healthy_fingerprint: "fp2", now: NOW)
+    assert_equal :wait, d.action
+    assert_equal "second_attempt_backoff", d.rationale
+    assert_equal NOW + P::SECOND_ATTEMPT_BACKOFF_SEC, d.eligible_at
+  end
+
+  def test_second_attempt_ready_after_window
+    since = NOW - P::SECOND_ATTEMPT_BACKOFF_SEC
+    rec = {
+      "attempts_dispatched" => 1,
+      "last_attempted_fingerprint" => "fp1",
+      "second_candidate_fingerprint" => "fp2",
+      "second_candidate_first_seen_at" => since.iso8601(6)
+    }
+    d = P.decide(record: rec, healthy_fingerprint: "fp2", now: NOW)
+    assert_equal :retry, d.action
+    assert_equal "second_attempt_ready", d.rationale
+  end
+
+  def test_exhausted_refuses
+    rec = { "attempts_dispatched" => 2, "phase" => "exhausted" }
+    d = P.decide(record: rec, healthy_fingerprint: "fp9", now: NOW)
+    assert_equal :refuse, d.action
+    assert_equal "exhausted", d.rationale
+  end
+
+  def test_negative_throttle
+    rec = {
+      "last_negative_signature" => "sig",
+      "last_negative_at" => NOW.iso8601(6)
+    }
+    refute P.should_emit_negative?(record: rec, signature: "sig", now: NOW + 60)
+    assert P.should_emit_negative?(record: rec, signature: "other", now: NOW + 60)
+    assert P.should_emit_negative?(
+      record: rec, signature: "sig",
+      now: NOW + P::NEGATIVE_DECISION_THROTTLE_SEC + 1
+    )
+  end
+end
diff --git a/test/unit/daemon/auto_retry/probe_runner_test.rb b/test/unit/daemon/auto_retry/probe_runner_test.rb
new file mode 100644
index 00000000..20d33dba
--- /dev/null
+++ b/test/unit/daemon/auto_retry/probe_runner_test.rb
@@ -0,0 +1,67 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "tmpdir"
+require "hive/daemon/auto_retry/probe_runner"
+
+class DaemonAutoRetryProbeRunnerTest < Minitest::Test
+  def runner
+    @runner ||= Hive::Daemon::AutoRetry::ProbeRunner.new(term_grace_sec: 0.2)
+  end
+
+  def test_successful_command
+    result = runner.run([ "true" ], timeout_sec: 5)
+    assert result.healthy?
+    refute result.timed_out
+  end
+
+  def test_nonzero_exit_unhealthy
+    result = runner.run([ "false" ], timeout_sec: 5)
+    refute result.healthy?
+    assert_equal "nonzero_exit", result.error
+  end
+
+  def test_timeout_kills_and_is_unhealthy
+    result = runner.run([ "sleep", "30" ], timeout_sec: 0.3)
+    refute result.healthy?
+    assert result.timed_out
+    assert_equal "timeout", result.error
+  end
+
+  def test_missing_executable
+    result = runner.run([ "/nonexistent/binary-xyz" ], timeout_sec: 2)
+    refute result.healthy?
+    assert_equal "missing_executable", result.error
+  end
+
+  def test_output_capped_and_redacted
+    r = Hive::Daemon::AutoRetry::ProbeRunner.new(excerpt_bytes: 80)
+    result = r.run(
+      [ "bash", "-c", "echo 'Authorization: Bearer sk-secret-token-1234567890'; dd if=/dev/zero bs=1 count=5000 2>/dev/null | tr '\\0' 'X'" ],
+      timeout_sec: 5
+    )
+    assert result.healthy?, result.inspect
+    refute_includes result.stdout, "sk-secret-token-1234567890"
+    assert result.stdout.bytesize <= 200, "stdout bytes=#{result.stdout.bytesize}"
+  end
+
+  def test_chdir_isolation
+    Dir.mktmpdir do |dir|
+      result = runner.run([ "bash", "-c", "pwd" ], timeout_sec: 5, chdir: dir)
+      assert result.healthy?
+      assert_includes result.stdout, dir
+    end
+  end
+
+  def test_pipe_filling_successful_child_is_drained_while_running
+    result = runner.run(
+      [ "ruby", "-e", '$stdout.write("x" * 262_144); $stderr.write("y" * 262_144)' ],
+      timeout_sec: 5
+    )
+
+    assert result.healthy?, result.inspect
+    refute result.timed_out
+    assert_operator result.stdout.bytesize, :<=, 2_048
+    assert_operator result.stderr.bytesize, :<=, 2_048
+  end
+end
diff --git a/test/unit/daemon/auto_retry/safety_test.rb b/test/unit/daemon/auto_retry/safety_test.rb
new file mode 100644
index 00000000..da2bb501
--- /dev/null
+++ b/test/unit/daemon/auto_retry/safety_test.rb
@@ -0,0 +1,203 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "tmpdir"
+require "fileutils"
+require "open3"
+require "hive/daemon/auto_retry/safety"
+require "hive/daemon/status_consumer"
+require "hive/markers"
+
+class DaemonAutoRetrySafetyTest < Minitest::Test
+  Row = Hive::Daemon::StatusConsumer::Row
+  Safety = Hive::Daemon::AutoRetry::Safety
+
+  FakeResult = Struct.new(:ok, :timed_out, :stdout, keyword_init: true) do
+    def healthy? = ok == true
+  end
+
+  class TimeoutRunner
+    def run(*) = FakeResult.new(ok: false, timed_out: true, stdout: "")
+  end
+
+  def make_git_repo
+    dir = Dir.mktmpdir("hive-safety-wt")
+    system("git", "init", "-q", dir, exception: true)
+    system("git", "-C", dir, "config", "user.email", "t@example.com", exception: true)
+    system("git", "-C", dir, "config", "user.name", "t", exception: true)
+    File.write(File.join(dir, "README"), "x\n")
+    system("git", "-C", dir, "add", "README", exception: true)
+    system("git", "-C", dir, "commit", "-qm", "init", exception: true)
+    dir
+  end
+
+  def row_for(folder:, stage: "4-execute", reason: "implementer_failed", marker_id: "m1",
+              worktree_path: nil, live_task_lock: false, marker: "error")
+    state = File.join(folder, "task.md")
+    File.write(state, "<!-- ERROR reason=#{reason} marker_id=#{marker_id} -->\n") unless File.exist?(state)
+    Row.new(
+      project: "demo",
+      slug: "task-slug-260601-abcd",
+      stage: stage,
+      workflow: "coding",
+      marker: marker,
+      marker_attrs: { "reason" => reason, "marker_id" => marker_id },
+      folder: folder,
+      state_file: state,
+      live_task_lock: live_task_lock,
+      worktree_path: worktree_path,
+      id: "42"
+    )
+  end
+
+  def test_clean_execute_worktree_is_safe
+    wt = make_git_repo
+    Dir.mktmpdir("hive-safety-task") do |folder|
+      row = row_for(folder: folder, worktree_path: wt)
+      result = Safety.new.check(row: row, observed_marker_id: "m1",
+                                observed_reason: "implementer_failed")
+      assert result.safe?, result.rationale
+    end
+  ensure
+    FileUtils.rm_rf(wt) if wt
+  end
+
+  def test_dirty_execute_worktree_unsafe
+    wt = make_git_repo
+    File.write(File.join(wt, "dirty.txt"), "nope\n")
+    Dir.mktmpdir("hive-safety-task") do |folder|
+      row = row_for(folder: folder, worktree_path: wt)
+      result = Safety.new.check(row: row, observed_marker_id: "m1",
+                                observed_reason: "implementer_failed")
+      refute result.safe?
+      assert_equal "dirty_worktree", result.rationale
+    end
+  ensure
+    FileUtils.rm_rf(wt) if wt
+  end
+
+  def test_blank_plan_is_safe
+    Dir.mktmpdir("hive-safety-plan") do |folder|
+      File.write(File.join(folder, "plan.md"), "<!-- ERROR reason=claude_launch_failed marker_id=m1 -->\n")
+      row = row_for(folder: folder, stage: "3-plan", reason: "claude_launch_failed")
+      result = Safety.new.check(row: row, observed_marker_id: "m1",
+                                observed_reason: "claude_launch_failed")
+      assert result.safe?, result.rationale
+    end
+  end
+
+  def test_plan_with_prose_is_unsafe
+    Dir.mktmpdir("hive-safety-plan") do |folder|
+      File.write(File.join(folder, "plan.md"), "# Plan\n\nDo the thing.\n")
+      row = row_for(folder: folder, stage: "3-plan", reason: "claude_launch_failed")
+      result = Safety.new.check(row: row, observed_marker_id: "m1",
+                                observed_reason: "claude_launch_failed")
+      refute result.safe?
+      assert_equal "plan_has_content", result.rationale
+    end
+  end
+
+  def test_plan_user_feedback_html_comment_is_unsafe
+    Dir.mktmpdir("hive-safety-plan") do |folder|
+      File.write(File.join(folder, "plan.md"), "<!-- Please preserve the existing API. -->\n")
+      row = row_for(folder: folder, stage: "3-plan", reason: "claude_launch_failed")
+      result = Safety.new.check(row: row, observed_marker_id: "m1",
+                                observed_reason: "claude_launch_failed")
+      refute result.safe?
+      assert_equal "plan_has_content", result.rationale
+    end
+  end
+
+  def test_brainstorm_user_feedback_html_comment_is_unsafe
+    Dir.mktmpdir("hive-safety-bs") do |folder|
+      File.write(File.join(folder, "brainstorm.md"), "<!-- Use the smaller scope. -->\n")
+      row = row_for(folder: folder, stage: "2-brainstorm", reason: "claude_launch_failed")
+      result = Safety.new.check(row: row, observed_marker_id: "m1",
+                                observed_reason: "claude_launch_failed")
+      refute result.safe?
+      assert_equal "malformed_brainstorm", result.rationale
+    end
+  end
+
+  def test_answered_brainstorm_unsafe
+    Dir.mktmpdir("hive-safety-bs") do |folder|
+      File.write(File.join(folder, "brainstorm.md"), <<~MD)
+        ## Round 1
+        ### Q1. What?
+        ### A1.
+        yes please
+      MD
+      row = row_for(folder: folder, stage: "2-brainstorm", reason: "claude_launch_failed")
+      result = Safety.new.check(row: row, observed_marker_id: "m1",
+                                observed_reason: "claude_launch_failed")
+      refute result.safe?
+      assert_equal "answered_questions", result.rationale
+    end
+  end
+
+  def test_finalize_is_merge_watcher_owned
+    Dir.mktmpdir("hive-safety-fin") do |folder|
+      row = row_for(folder: folder, stage: "8-finalize", reason: "claude_launch_failed")
+      result = Safety.new.check(row: row, observed_marker_id: "m1",
+                                observed_reason: "claude_launch_failed")
+      refute result.safe?
+      assert_equal "merge_watcher_owned", result.rationale
+    end
+  end
+
+  def test_live_lock_blocks
+    wt = make_git_repo
+    Dir.mktmpdir("hive-safety-lock") do |folder|
+      row = row_for(folder: folder, worktree_path: wt, live_task_lock: true)
+      result = Safety.new.check(row: row, observed_marker_id: "m1",
+                                observed_reason: "implementer_failed")
+      refute result.safe?
+      assert_equal "live_task_lock", result.rationale
+    end
+  ensure
+    FileUtils.rm_rf(wt) if wt
+  end
+
+  def test_marker_id_rotation_blocks
+    wt = make_git_repo
+    Dir.mktmpdir("hive-safety-rot") do |folder|
+      row = row_for(folder: folder, worktree_path: wt, marker_id: "newid")
+      result = Safety.new.check(row: row, observed_marker_id: "oldid",
+                                observed_reason: "implementer_failed")
+      refute result.safe?
+      assert_equal "marker_id_changed", result.rationale
+    end
+  ensure
+    FileUtils.rm_rf(wt) if wt
+  end
+
+  def test_reread_detects_lock_created_after_status_probe
+    wt = make_git_repo
+    Dir.mktmpdir("hive-safety-race") do |folder|
+      row = row_for(folder: folder, worktree_path: wt)
+      Hive::Lock.acquire_task_lock(folder, "command" => "run")
+      result = Safety.new.check(row: row, observed_marker_id: "m1",
+                                observed_reason: "implementer_failed", re_read: true)
+      refute result.safe?
+      assert_equal "live_task_lock", result.rationale
+    ensure
+      Hive::Lock.release_task_lock(folder)
+    end
+  ensure
+    FileUtils.rm_rf(wt) if wt
+  end
+
+  def test_git_status_timeout_fails_closed
+    wt = make_git_repo
+    Dir.mktmpdir("hive-safety-timeout") do |folder|
+      row = row_for(folder: folder, worktree_path: wt)
+      result = Safety.new(runner: TimeoutRunner.new).check(
+        row: row, observed_marker_id: "m1", observed_reason: "implementer_failed"
+      )
+      refute result.safe?
+      assert_equal "git_status_timeout", result.rationale
+    end
+  ensure
+    FileUtils.rm_rf(wt) if wt
+  end
+end
diff --git a/test/unit/daemon/auto_retry/state_test.rb b/test/unit/daemon/auto_retry/state_test.rb
new file mode 100644
index 00000000..bfdf87aa
--- /dev/null
+++ b/test/unit/daemon/auto_retry/state_test.rb
@@ -0,0 +1,143 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "tmpdir"
+require "hive/daemon/auto_retry/state"
+require "hive/daemon/auto_retry/policy"
+
+class DaemonAutoRetryStateTest < Minitest::Test
+  def queue_retry(state, recovery_id:, phase: "retry_queued", **attrs)
+    state.upsert!(
+      project: "p", task_key: "t1", stage: "4-execute", reason: "implementer_failed",
+      phase: phase, recovery_id: recovery_id, **attrs
+    )
+  end
+
+  def with_state
+    Dir.mktmpdir("hive-auto-retry-state") do |dir|
+      path = File.join(dir, "daemon_auto_retry.json")
+      state = Hive::Daemon::AutoRetry::State.new(path: path, clock: -> { Time.utc(2026, 6, 1, 12, 0, 0) })
+      yield state, path
+    end
+  end
+
+  def test_upsert_and_get
+    with_state do |state, _path|
+      state.upsert!(project: "p", task_key: "t1", stage: "4-execute", reason: "implementer_failed",
+                    phase: "candidate", marker_id: "abc")
+      rec = state.get(project: "p", task_key: "t1", stage: "4-execute", reason: "implementer_failed")
+      assert_equal "candidate", rec["phase"]
+      assert_equal "abc", rec["marker_id"]
+      assert_equal 0, rec["attempts_dispatched"]
+    end
+  end
+
+  def test_mark_dispatched_increments_attempts
+    with_state do |state, _path|
+      queue_retry(state, recovery_id: "ar-1")
+      state.mark_dispatched!(project: "p", task_key: "t1", stage: "4-execute",
+                             reason: "implementer_failed", fingerprint: "fp1",
+                             recovery_id: "ar-1")
+      rec = state.get(project: "p", task_key: "t1", stage: "4-execute", reason: "implementer_failed")
+      assert_equal 1, rec["attempts_dispatched"]
+      assert_equal "fp1", rec["last_attempted_fingerprint"]
+      assert_equal "retry_dispatched", rec["phase"]
+    end
+  end
+
+  def test_marker_id_does_not_create_new_budget
+    with_state do |state, _path|
+      queue_retry(state, recovery_id: "ar-1", marker_id: "old")
+      state.mark_dispatched!(project: "p", task_key: "t1", stage: "4-execute",
+                             reason: "implementer_failed", fingerprint: "fp1",
+                             recovery_id: "ar-1")
+      state.upsert!(project: "p", task_key: "t1", stage: "4-execute", reason: "implementer_failed",
+                    marker_id: "new")
+      rec = state.get(project: "p", task_key: "t1", stage: "4-execute", reason: "implementer_failed")
+      assert_equal 1, rec["attempts_dispatched"]
+      assert_equal "new", rec["marker_id"]
+    end
+  end
+
+  def test_manual_rearm_resets_attempts
+    with_state do |state, _path|
+      state.upsert!(project: "p", task_key: "t1", stage: "4-execute", reason: "implementer_failed")
+      2.times do |i|
+        queue_retry(state, recovery_id: "ar-#{i}")
+        state.mark_dispatched!(project: "p", task_key: "t1", stage: "4-execute",
+                               reason: "implementer_failed", fingerprint: "fp#{i}",
+                               recovery_id: "ar-#{i}")
+      end
+      state.mark_exhausted!(project: "p", task_key: "t1", stage: "4-execute",
+                            reason: "implementer_failed")
+      state.rearm_manual!(project: "p", task_key: "t1", stage: "4-execute",
+                          reason: "implementer_failed")
+      rec = state.get(project: "p", task_key: "t1", stage: "4-execute", reason: "implementer_failed")
+      assert_equal 0, rec["attempts_dispatched"]
+      assert_equal "candidate", rec["phase"]
+    end
+  end
+
+  def test_corrupt_state_suspends
+    with_state do |state, path|
+      File.write(path, "{not json")
+      loaded = state.load_all
+      assert_equal({}, loaded)
+      assert state.suspended?
+      assert_raises(Hive::Daemon::AutoRetry::State::Suspended) do
+        state.upsert!(project: "p", task_key: "t", stage: "4-execute", reason: "x")
+      end
+    end
+  end
+
+  def test_structurally_corrupt_records_suspends_without_resetting_budget
+    with_state do |state, path|
+      File.write(path, JSON.generate("schema_version" => 1, "records" => []))
+
+      assert_equal({}, state.load_all)
+      assert state.suspended?
+      assert_equal "records_not_hash", state.suspend_reason
+      assert_raises(Hive::Daemon::AutoRetry::State::Suspended) do
+        state.upsert!(project: "p", task_key: "t", stage: "4-execute", reason: "x")
+      end
+    end
+  end
+
+  def test_dispatch_accounting_is_idempotent_for_same_recovery
+    with_state do |state, _path|
+      queue_retry(state, recovery_id: "ar-stable")
+      2.times do
+        state.mark_dispatched!(project: "p", task_key: "t1", stage: "4-execute",
+                               reason: "implementer_failed", fingerprint: "fp1",
+                               recovery_id: "ar-stable")
+      end
+
+      rec = state.get(project: "p", task_key: "t1", stage: "4-execute",
+                      reason: "implementer_failed")
+      assert_equal 1, rec["attempts_dispatched"]
+      assert_equal "retry_dispatched", rec["phase"]
+    end
+  end
+
+  def test_newer_schema_suspends_writes
+    with_state do |state, path|
+      File.write(path, JSON.generate("schema_version" => 99, "records" => {}))
+      state.load_all
+      assert state.suspended?
+      assert_equal "newer_schema", state.suspend_reason
+    end
+  end
+
+  def test_keys_isolated_by_reason
+    with_state do |state, _path|
+      state.upsert!(project: "p", task_key: "t1", stage: "4-execute", reason: "implementer_failed",
+                    attempts_dispatched: 1)
+      state.upsert!(project: "p", task_key: "t1", stage: "4-execute", reason: "claude_launch_failed",
+                    attempts_dispatched: 0)
+      a = state.get(project: "p", task_key: "t1", stage: "4-execute", reason: "implementer_failed")
+      b = state.get(project: "p", task_key: "t1", stage: "4-execute", reason: "claude_launch_failed")
+      assert_equal 1, a["attempts_dispatched"]
+      assert_equal 0, b["attempts_dispatched"]
+    end
+  end
+end
diff --git a/test/unit/daemon/dispatch_request_queue_test.rb b/test/unit/daemon/dispatch_request_queue_test.rb
index a3c6f5e7..5f34ed0c 100644
--- a/test/unit/daemon/dispatch_request_queue_test.rb
+++ b/test/unit/daemon/dispatch_request_queue_test.rb
@@ -175,6 +175,32 @@ class HiveDaemonDispatchRequestQueueTest < Minitest::Test
     end
   end
 
+  def test_auto_retry_idempotence_rejects_request_id_collision
+    Dir.mktmpdir("hive-dispatch-queue") do |dir|
+      argv = [ "hive", "run", "slug-x", "--json" ]
+      Q.write_request!(
+        project: "hive", slug: "slug-x", argv: argv,
+        requestor: "auto_retry", request_id: "recovery-request",
+        recovery_id: "ar-one", recovery_step: "rerun", state_home: dir
+      )
+
+      assert_equal "recovery-request", Q.write_request!(
+        project: "hive", slug: "slug-x", argv: argv,
+        requestor: "auto_retry", request_id: "recovery-request",
+        recovery_id: "ar-one", recovery_step: "rerun", state_home: dir
+      )
+      error = assert_raises(ArgumentError) do
+        Q.write_request!(
+          project: "hive", slug: "slug-x",
+          argv: [ "hive", "archive", "slug-x", "--json" ],
+          requestor: "auto_retry", request_id: "recovery-request",
+          recovery_id: "ar-one", recovery_step: "rerun", state_home: dir
+        )
+      end
+      assert_includes error.message, "collides with different recovery metadata"
+    end
+  end
+
   def test_remove_ignores_empty_request_id
     Dir.mktmpdir("hive-dispatch-queue") do |dir|
       refute Q.remove("", state_home: dir)
